if ($Server::shiftBrickCarControlsVersion > 2)
   return;

//changes for 2:
//Moved parent to always happen so that brick controls work as usual, if building from a car (for some reason) or if another add-on wants to use them

$Server::shiftBrickCarControlsBrickVersion = 2;

if (isPackage(shiftBrickCarControls))
{
    deactivatePackage(shiftBrickCarControls);   //De-activates package with the same name if there is any. Safety measure.
}

package shiftBrickCarControls
{
    function ServerCmdShiftBrick(%client, %x, %y, %z)   //Brick shift controls
    {
        parent::ServerCmdShiftBrick(%client, %x, %y, %z); //use brick controls like usual.
        if(isObject(%client.player) && isObject(%veh = %client.player.getObjectMount()))
        { //If the player exists and is mounted to a vehicle,
            %data = %veh.getDataBlock();
            if(%data.shiftBrickCarControls) //see if the vehicle has the variable indicating it uses this script
            { //If the variable exists, set %input based on the brick control used. Numbers are based on default keybinds.
                %node = %client.player.getMountNode();
                if(%z == -1) %input = 1;        //Down 1/3
                else if(%x == -1) %input = 2;   //Toward
                else if(%z == 1) %input = 3;    //Up 1/3
                else if(%y == 1) %input = 4;    //Left
                else if(%z == -3) %input = 5;   //Down
                else if(%y == -1) %input = 6;   //Right
                else if(%x == 1) %input = 8;    //Away
                else if(%z == 3) %input = 10;   //Up

                %data.shiftBrickCarControls(%veh, %client, %node, %input, 0);
            }
        }
    }

    function ServerCmdSuperShiftBrick(%client, %x, %y, %z)
    {
        parent::ServerCmdSuperShiftBrick(%client, %x, %y, %z);
        if(isObject(%client.player) && isObject(%veh = %client.player.getObjectMount()))
        { //If the player exists and is mounted to a vehicle,
            %data = %veh.getDataBlock();
            if(%data.shiftBrickCarControls) //see if the vehicle has the variable indicating it uses this script
            { //If the variable exists, set %input based on the brick control used. Numbers are based on default keybinds.
                %node = %client.player.getMountNode();
                if(%z == -1) %input = 5;        //Super shift down
                else if(%x == -1) %input = 2;   //Super shift toward
                else if(%z == 1) %input = 10;   //Super shift up
                else if(%y == 1) %input = 4;    //Super shift left
                else if(%y == -1) %input = 6;   //Super shift right
                else if(%x == 1) %input = 8;    //Super shift away

                //Super shift allows these six additional controls. (Note that 1, 3, 7, and 9 are missing)
                //Switching to super shift is not recognized on any other brick controls.

                %data.shiftBrickCarControls(%veh, %client, %node, %input, 1);
                    //The last variable in the function is switched to 1 to indicate super shift.
                    //The vehicle may choose to treat this number differently, or just use the number and ignore super shift.
            }
        }
    }

    function ServerCmdRotateBrick(%client, %r)
    {
        parent::ServerCmdRotateBrick(%client, %r);
        if(isObject(%client.player) && isObject(%veh = %client.player.getObjectMount()))
        { //If the player exists and is mounted to a vehicle,
            %data = %veh.getDataBlock();
            if(%data.shiftBrickCarControls) //see if the vehicle has the variable indicating it uses this script
            { //If the variable exists, set %input based on the brick control used. Numbers are based on default keybinds.
                %node = %client.player.getMountNode();
                if(%r == -1) %input = 7;        //Rotate CCW
                else if(%r == 1) %input = 9;   //Rotate CW

                %data.shiftBrickCarControls(%veh, %client, %node, %input, 0);
            }
        }
    }

    function ServerCmdPlantBrick(%client)
    {
        parent::ServerCmdPlantBrick(%client);
        if(isObject(%client.player) && isObject(%veh = %client.player.getObjectMount()))
        { //If the player exists and is mounted to a vehicle,
            %data = %veh.getDataBlock();
            if(%data.shiftBrickCarControls) //see if the vehicle has the variable indicating it uses this script
            { //If the variable exists, set %input based on the brick control used. Numbers are based on default keybinds.
                %node = %client.player.getMountNode();
                %data.shiftBrickCarControls(%veh, %client, %node, 11, 0); //%input for plant is 11
            }
        }
    }

    function ServerCmdCancelBrick(%client)
    {
        parent::ServerCmdCancelBrick(%client);
        if(isObject(%client.player) && isObject(%veh = %client.player.getObjectMount()))
        { //If the player exists and is mounted to a vehicle,
            %data = %veh.getDataBlock();
            if(%data.shiftBrickCarControls) //see if the vehicle has the variable indicating it uses this script
            { //If the variable exists, set %input based on the brick control used. Numbers are based on default keybinds.
                %node = %client.player.getMountNode();
                %data.shiftBrickCarControls(%veh, %client, %node, 0, 0); //%input for cancel is 0
            }
        }
    }
};
activatePackage(shiftBrickCarControls);