datablock fxLightData(lawnmower90HeadLight)
{
	radius = 15;
	brightness = 5;
	color = "1 0.75 0.50 1";
	flareOn = false;
};

datablock WheeledVehicleData(lawnmower90vehicle)
{
	category = "Vehicles";
	uiName = "LawnMaster '90";
	shapeFile = "./shapes/lawnmower90v2.dts";
	
	handsOnVehicle = 1;
	// shiftBrickCarControls = 1;
	hasScriptedHeadlights = 1;
	usesVehicleEditHelper = 1;
	storedColorScheme = 1;
	colorSchemeIdentifier = "lawnmower90";

	defaultTire = lawnmower90tire;
	defaultSpring = lawnmower90spring;

	// tireEmitter = no

	// numFactoryColorGroups = 4;

	numFactoryColors = 11;

	factoryColor[1] = "2F7032 Green";
	factoryColor[2] = "BB2020 Red";
	factoryColor[3] = "F0BE0E Yellow";
	factoryColor[4] = "6A1E1E Dark red";
	factoryColor[5] = "0F3012 Dark green";
	factoryColor[6] = "FF651A Orange";
	factoryColor[7] = "3576B2 Blue";
	factoryColor[8] = "F0F0F0 White";
	factoryColor[9] = "8A8D92 Silver";
	factoryColor[10] = "4C4C4F Gray";
	factoryColor[11] = "1A1A1A Black";

	engineTorque = 5000;
	engineBrake = 250;
	brakeTorque = 1000;
	maxWheelSpeed = 12.5;

	mass = 300;
	massCenter = "0 0 0.03";
	
	rotationalDrag = 0;
	drag = 0.5;
	bodyFriction = 0.25;
	bodyRestitution = 0.25;

	displayName = "";
	emap = true;
	minMountDist = 3;

	numMountPoints = 1;
	mountThread[0] = "sit";

	rollForce = 0;
	yawForce = 0;
	pitchForce = 1000;

	rideable = true;
	lookUpLimit = 0.6;
	lookDownLimit = 0.5;
 
	paintable = true;

	maxDamage = 200.00;
	destroyedLevel = 400.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	maxSteeringAngle = 0.95;
	integration = 4;
	//tireEmitter = none;

	cameraRoll = false;
	cameraMaxDist = 8;
	cameraOffset = 4;
	cameraTilt = 0.3;

	cameraLag = 0.0;
	cameraDecay = 0.75;
	collisionTol = 0.1;
	contactTol = 0.1;

	useEyePoint = false;	

	numWheels = 4;

	density = 5.0;
	minImpactSpeed = 10;
	softImpactSpeed = 10;
	hardImpactSpeed = 15;
	groundImpactMinSpeed = 10.0;

	steeringAutoReturn = true;
	steeringAutoReturnRate = 0.05;
	steeringAutoReturnMaxSpeed = 0.1;
	steeringUseStrafeSteering = true;
	steeringStrafeSteeringRate = 0.05;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
   
	damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

	damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

	numDmgEmitterAreas = 1;

	initialExplosionProjectile = vehicleExplosionProjectile;
	initialExplosionOffset = 0;

	burnTime = 4000;

	finalExplosionProjectile = vehicleFinalExplosionProjectile;
	finalExplosionOffset = 0.5;

	minRunOverSpeed    = 4;
	runOverDamageScale = 8;
	runOverPushScale   = 1.2;

	protectPassengersBurn   = false;
	protectPassengersRadius = true;
	protectPassengersDirect = false;
};
