package lawnmower90Package
{
    function lawnmower90Vehicle::onAdd(%this, %veh)
    {
        Parent::onAdd(%this, %veh);
        
        %veh.checkGrass(%veh);
        %veh.fanBlade(%veh);

        %veh.spawnMountedLightBot(1);
        
        %veh.setWheelPowered(0, 0);
        %veh.setWheelPowered(1, 0);

        %veh.setWheelTire(2, lawnmower90reartire);
        %veh.setWheelTire(3, lawnmower90reartire);

        %veh.setWheelSpring(2, lawnmower90rearspring);
        %veh.setWheelSpring(3, lawnmower90rearspring);

        %veh.hidenode(headlight1);

        %veh.colorSchemeTarget = 0;

        %this.schedule(100, loadSpawnBrickAttributes, %veh);
    }

    function lawnmower90vehicle::setDefaultBrickAttributes(%this, %veh)
    {
        //announce("Setting random values.");

        %brick = %veh.spawnbrick;
        %ID = %this.colorSchemeIdentifier;

        %brick.numColorSchemeTargets[%ID] = 2;

        %a = getRandom(%this.numFactoryColors - 1) + 1; //Choose a random index from the list of factory colors in the vehicle's datablock
        %randomBaseColor = getColorF(getWord(%this.factoryColor[%a], 0)); //Take the first word from the string (a hex code) and make it a color

        %brick.colorSchemeName[%ID, 0] = "Base"; //base colorSchemeNodes are not defined, as it is "everything else"
        %brick.colorSchemeColor[%ID, 0] = %randomBaseColor;

        %b = %this.getRandomStripeColor(%a);

        %brick.colorSchemeName[%ID, 1] = "Stripe";
        %brick.colorSchemeNodes[%ID, 1] = "stripe";
        %brick.colorSchemeColor[%ID, 1] = %b;

        %brick.carAttributesSet[%ID] = true;

        %this.schedule(50, loadSpawnBrickAttributes, %veh);
        //%this.loadSpawnBrickAttributes(%veh);

        return;
    }

    function lawnmower90vehicle::loadSpawnBrickAttributes(%this, %veh)
    {
        // announce("load attributes " @ %this);
        %brick = %veh.spawnbrick;
        %ID = %this.colorSchemeIdentifier;

        if(!%brick.carAttributesSet[%ID]) //If the car has never been spawned before, randomize some specific visual elements.
        {
            return %this.setDefaultBrickAttributes(%veh);
        }

        %veh.numColorSchemeTargets = %brick.numColorSchemeTargets[%ID]; //Apply color-related traits to the car itself, as saved on the brick

        //Tell the car what the brick has saved for its current color scheme.
        for(%i = 0; %i < %brick.numColorSchemeTargets[%ID]; %i++)
        {
            //announce(%brick.colorSchemeName[%this, %i]);
            %veh.colorSchemeName[%i] = %brick.colorSchemeName[%ID, %i];
            //Let the car know what each group is called.
            if(%i > 0) //On all but base, get the nodes and defaults
            {
                %veh.colorSchemeNodes[%i] = %brick.colorSchemeNodes[%ID, %i];
                // %veh.colorSchemeDefault[%i] = %brick.colorSchemeDefault[%ID, %i];
                //Lawnmower has no defaults for each scheme (the stripe, if it has no color of its own, will always be the same as base)
            }
            // %veh.colorSchemeFactoryColorGroup[%i] = %brick.colorSchemeFactoryColorGroup[%ID, %i];
            //Lawnmower has no factory color groups. Both share the same colors.
            %veh.colorSchemeColor[%i] = %brick.colorSchemeColor[%ID, %i];
            //Now the car knows its colors.
        }

        
        //Now to color the vehicle.
        //Account for "Re-Color vehicle" on bricks.
        %colorSchemeTargetRestore = %veh.colorSchemeTarget; //Temp variable so that behavior doesn't change based on current target.
        %veh.colorSchemeTarget = 0;
        if(%brick.reColorVehicle)
            %brick.colorVehicle(); //If the brick has control, let this script color the base as expected.
        else
            %veh.setNodeColor("ALL", %veh.colorSchemeColor[0]); //Otherwise, paint it all with our current color scheme.
        %veh.colorSchemeTarget = %colorSchemeTargetRestore;
    }

    function lawnmower90vehicle::getRandomStripeColor(%this, %a)
    {
        switch(%a)
        {
            case 1: //green
                %b = 3; //yellow

            case 2: //red
                %b = 11; //black

            case 3: //yellow
                %b = 11; //black

            case 4: //burgundy
                %b = 6; //orange

            case 5: //dark green
                %b = 8; //white

            case 6: //orange
                %b = 10; //gray

            case 7: //blue
                %b = 2; //red

            case 8: //white
                %b = 7; //blue

            case 9: //silver
                %b = 6; //orange

            case 10: //gray
                %b = 2; //red

            case 11: //black
                %b = 3; //yellow
        }

        if(%b == -1)
            %b = "0 0 0 0";
        else
            %b = getColorF(getWord(%this.factoryColor[%b], 0));

        return %b;
    }
};
activatepackage(lawnmower90Package);

package onDriverEnterPackage
{
    function armor::onMount(%this, %obj, %vehicle, %node)
    {
        Parent::onMount(%this, %obj, %vehicle, %node);
        
        if(%node == 0 && isObject(%vehicle) && isFunction(%vehicle.dataBlock, onDriverEnter))
            %vehicle.dataBlock.onDriverEnter(%vehicle, %obj);
    }

};
activatePackage(onDriverEnterPackage);

function lawnmower90Vehicle::onDriverEnter(%this, %veh)
{   
    //onDriverEnter and onDriverLeave both are called many times (up to 14) for some reason.
    // The hasDriver variable makes it so these things are done only one time each.
    if(!%veh.hasDriver)
    {
        %veh.hasDriver = 1;
        
        %this.headlights(%veh, "restore");
        
        // %this.SpeedCheck(%veh);
    }
}

function lawnmower90Vehicle::onDriverLeave(%this, %veh)
{       
    if(%veh.hasDriver)
    {
        %veh.hasDriver = 0;

        // if(%veh.braking)
        // {
        //     %veh.braking = 0;
        //     %veh.partsBot.hidenode(lights_brakeR2);
        //     %veh.partsBot.hidenode(lights_brakeL2); 

            // if(%veh.headlightState > 0)
            // {
            //     %veh.partsBot.unhidenode(lights_brakeR1);
            //     %veh.partsBot.unhidenode(lights_brakeL1); 
            // }
            // else
            // {
            //     %veh.partsBot.unhidenode(lights_brakeR0);
            //     %veh.partsBot.unhidenode(lights_brakeL0); 
            // }
        // }
        
        // %veh.reversing = 0;
        // %veh.partsBot.unhidenode(lights_reverse0);
        // %veh.partsBot.hidenode(lights_reverse1);

        // cancel(%veh.SpeedCheckSchedule);
        // if(%veh.signal != -11) %this.turnSignal(%veh, 0);
        %veh.mountedLightBot[1].setMountedLight(none);
    }
}

function lawnmower90Vehicle::onRemove(%this, %veh)
{
    %veh.removeMountedLightBot(1);
}

// function lawnmower90Vehicle::SpeedCheck(%this, %veh)
// {
//     if(isEventPending(%veh.SpeedCheckSchedule)) return;
//     if(!isObject(%veh)) return;
    
//     %veh.speed = vectorDot(%veh.getVelocity(), %veh.getForwardVector());
    
//     if(!%veh.reversing && %veh.speed <= -3)
//     {
//         %veh.partsBot.hidenode(lights_reverse0);
//         %veh.partsBot.unhidenode(lights_reverse1);
//         %veh.reversing = 1;
//     }
//     else if(%veh.reversing && %veh.speed > -0.1)
//     {
//         %veh.partsBot.unhidenode(lights_reverse0);
//         %veh.partsBot.hidenode(lights_reverse1);
//         %veh.reversing = 0;
//     }
    
//     %veh.SpeedCheckSchedule = %this.schedule(250, "SpeedCheck", %veh);
// }

// function lawnmower90Vehicle::SpeedCheck(%this, %veh)
// {
//     if(isEventPending(%veh.SpeedCheckSchedule)) return;
//     if(!isObject(%veh)) return;

//     %c = %veh.getMountedObject(0).client;
    
//     %veh.speed = vectorDot(%veh.getVelocity(), %veh.getForwardVector());

//     %veh.sidespeed = vectorDot(%veh.getVelocity(), VectorCross(%veh.getForwardVector(), %veh.getUpVector()));

//     %veh.airspeed = vectorDist("0 0 0", %veh.getVelocity())*2;

//     %veh.airaccel = (%veh.airspeed-%veh.prevairspeed) / (25/1000);
//     %veh.prevairspeed = %veh.airspeed;

//     %avgtotal = 0;
//     %avgcount = 250;
//     for(%i = %avgcount; %i > 0; %i--)
//     {
//         %veh.prevaccel[%i] = %veh.prevaccel[%i-1];
//         %avgtotal = %veh.prevaccel[%i] + %avgtotal;
//     }
//     %veh.prevaccel[0] = %veh.airaccel;
//     %avgtotal = %veh.prevaccel[0] + %avgtotal;

//     %avgaccel = %avgtotal / %avgcount;

//     %c.bottomprint( 

//                     // mfloor(%veh.speed*2*100)/100 NL
//                     // mfloor(%veh.acceleration*2*100) NL
//                     // mfloor(%veh.sidespeed*2*100)/100 NL
//                     "Velocity:" @ %veh.airspeed NL
//                     // "Global acceleration: " @ %veh.airaccel NL
//                     "Acceleration:" @ %veh.airaccel NL
//                     "Average acceleration:" @ %avgaccel NL
//                     %veh.prevaccel[0] NL
//                     %veh.prevaccel[1] NL
//                     %veh.prevaccel[2] NL
//                     %veh.prevaccel[3] NL
//                     %veh.prevaccel[4]);
    
//     if(!%veh.reversing && %veh.speed <= -3)
//     {
//         %veh.hidenode(lights_reverse0);
//         %veh.unhidenode(lights_reverse1);
//         %veh.reversing = 1;
//     }
//     else if(%veh.reversing && %veh.speed > -0.1)
//     {
//         %veh.unhidenode(lights_reverse0);
//         %veh.hidenode(lights_reverse1);
//         %veh.reversing = 0;
//     }
    
//     %veh.SpeedCheckSchedule = %this.schedule(25, "SpeedCheck", %veh);
// }
